//Lion.cpp - implementation of Lion class

#include "Lion.h"
#include "Ant.h"
using namespace std;

//default constructor (just for type-testing)
Lion::Lion(){}

//"practical" constructor used for lions we want to use
//takes in a pointer to the world and the width and height of the world
Lion::Lion( World *worldIn, int widthIn, int heightIn ){
	world = worldIn;
	width = widthIn;
	height = heightIn;
	livedfor = 0;//life begins now!
	lastate = 0;//death watch begins now, too!
}

//virtual destructor
Lion::~Lion(){}

//eat an ant if one is available in surrounding eight squares
//else, try to move to a side-facing adjacent space
void Lion::move(){

	//a nonce Organism to plunk down behind itself if it moves
	Organism *spaceFiller;

	//only move once per iteration
	if (this->isTurn()) return;
	//okay, no more after this
	this->endTurn();

	//increment lived for
	livedfor ++;

	//1. if there is an ant in an adjacent cell, eat the ant!
	//for this and only this, this can include diagonals

	//here so we don't eat twice
	bool alreadyAte = false;
	vector<int> canEat;//places with ants that I can eat
	canEat.clear();

	//find available ants:
				if (x>0)
				{
					Ant *pAntn = dynamic_cast<Ant*>(this->world->getOrganism(x-1,y));//N
				    if ((long)pAntn != 0)//it's an ant!
					{
						canEat.push_back(N);//add the N direction to the vector of ants to eat
					}
				}

				if (y>0)
				{
					Ant *pAntw = dynamic_cast<Ant*>(this->world->getOrganism(x,y-1));//W
				    if ((long)pAntw != 0)
					{
						canEat.push_back(W);
					}
				}
				if (y<width-1)
				{
					Ant *pAnte = dynamic_cast<Ant*>(this->world->getOrganism(x,y+1));//E
				    if ((long)pAnte != 0)
					{
						canEat.push_back(E);
					}
				}

				if (x<height-1)
				{
					Ant *pAnts = dynamic_cast<Ant*>(this->world->getOrganism(x+1,y));//S
				    if ((long)pAnts != 0)
					{
						canEat.push_back(S);
					}
				}
				if (x>0 && y>0)
				{
					Ant *pAntnw = dynamic_cast<Ant*>(this->world->getOrganism(x-1,y-1));//NW
				    if ((long)pAntnw != 0)
					{
						canEat.push_back(NW);
					}
				}
				if (x<height-1 && y>0)
				{
					Ant *pAntsw = dynamic_cast<Ant*>(this->world->getOrganism(x+1,y-1));//SW
				    if ((long)pAntsw != 0)
					{
						canEat.push_back(SW);
					}
				}
				if(x>0 && y<width-1)
				{
					Ant *pAntne = dynamic_cast<Ant*>(this->world->getOrganism(x-1,y+1));//NE
				    if ((long)pAntne != 0)
					{
						canEat.push_back(NE);
					}
				}
				if (x<height-1 && y<width-1)
				{
					Ant *pAntse = dynamic_cast<Ant*>(this->world->getOrganism(x+1,y+1));//SE
				    if ((long)pAntse != 0)
					{
						canEat.push_back(SE);
					}
				}

				//if we found an ant, pick one to eat at random
				if (canEat.size() > 0)
				{
					eat(canEat.at(this->world->genrand(canEat.size())));
					alreadyAte = true;
				}


	//2. If it hasn't eaten, move according to the same rules as the ant.
				if (!alreadyAte)
				{ //pick a dir
					
					lastate ++;//increment death watch!
					
					//pick a direction
					int randomdir = this->world->genrand(4);
					
					//try to move in that dir
					switch (randomdir) {
					  case 0://N
						//can we move north?
						  	if (x>0)
							{
								Lion *pLion = dynamic_cast<Lion*>(this->world->getOrganism(x-1,y));//N
								if ((long)pLion == 0) //it's free (no lion there); I can move
									//I would have eaten an ant already if there were any
								{
									this->setPosition(x-1,y);//change my coordinates
									Organism *pOrg = this;
									this->world->setOrganism(pOrg,x,y);//place myself
									spaceFiller = new Organism;
									this->world->setOrganism(spaceFiller,x+1,y);//place the nonce
								}
							}
						break;
					  case 1://E
							if (y<width-1)
							{
								Lion *pLion = dynamic_cast<Lion*>(this->world->getOrganism(x,y+1));//E
								if ((long)pLion == 0)
								{
									this->setPosition(x,y+1);
									Organism *pOrg = this;
									this->world->setOrganism(pOrg,x,y);
									spaceFiller = new Organism;
									this->world->setOrganism(spaceFiller,x,y-1);
								}
							}
						break;
					  case 2://S
							if (x<height-1)
							{
								Lion *pLion = dynamic_cast<Lion*>(this->world->getOrganism(x+1,y));//S
								if ((long)pLion == 0)
								{
									this->setPosition(x+1,y);
									Organism *pOrg = this;
									this->world->setOrganism(pOrg,x,y);
									spaceFiller = new Organism;
									this->world->setOrganism(spaceFiller,x-1,y);
								}
							}
						break;
					  case 3://W
							if (y>0)
							{
								Lion *pLion = dynamic_cast<Lion*>(this->world->getOrganism(x,y-1));//W
								if ((long)pLion == 0)
								{
									this->setPosition(x,y-1);
									Organism *pOrg = this;
									this->world->setOrganism(pOrg,x,y);
									spaceFiller = new Organism;
									this->world->setOrganism(spaceFiller,x,y+1);
								}
							}
						break;
					  default://WUT
						cout << "ROAR! Undefined direction, bub!";
					  }
				
				}
				else //Whew! We ate!
				{
				    lastate=0;
				}

}

//eat ant given a direction
void Lion::eat(int dirIn){

	//nonce organism to leave behind after eating
	Organism *spaceFiller;

	            if (dirIn==N)//eat ant to the north
				{
						this->setPosition(x-1,y);//change my coordinates
						Organism *pOrg = this;
						this->world->setOrganism(pOrg,x,y);//place myself
						spaceFiller = new Organism;
						this->world->setOrganism(spaceFiller,x+1,y);//place the nonce
				}
				else if (dirIn==W)
				{
	 					this->setPosition(x,y-1);
						Organism *pOrg = this;
						this->world->setOrganism(pOrg,x,y);
						spaceFiller = new Organism;
						this->world->setOrganism(spaceFiller,x,y+1);
				}
				else if (dirIn==E)
				{
						this->setPosition(x,y+1);
						Organism *pOrg = this;
						this->world->setOrganism(pOrg,x,y);
						spaceFiller = new Organism;
						this->world->setOrganism(spaceFiller,x,y-1);
				}
				else if (dirIn==S)
				{
						this->setPosition(x+1,y);
						Organism *pOrg = this;
						this->world->setOrganism(pOrg,x,y);
						spaceFiller = new Organism;
						this->world->setOrganism(spaceFiller,x-1,y);
				}
				else if (dirIn==NW)
				{
						this->setPosition(x-1,y-1);
						Organism *pOrg = this;
						this->world->setOrganism(pOrg,x,y);
						spaceFiller = new Organism;
						this->world->setOrganism(spaceFiller,x+1,y+1);
				}
				else if (dirIn==SW)
				{
						this->setPosition(x+1,y-1);
						Organism *pOrg = this;
						this->world->setOrganism(pOrg,x,y);
						spaceFiller = new Organism;
						this->world->setOrganism(spaceFiller,x-1,y+1);
				}
				else if(dirIn==NE)
				{
						this->setPosition(x-1,y+1);
						Organism *pOrg = this;
						this->world->setOrganism(pOrg,x,y);
						spaceFiller = new Organism;
						this->world->setOrganism(spaceFiller,x+1,y-1);
				}
				else //(dirIn==SE)
				{
						this->setPosition(x+1,y+1);
						Organism *pOrg = this;
						this->world->setOrganism(pOrg,x,y);
						spaceFiller = new Organism;
						this->world->setOrganism(spaceFiller,x-1,y-1);
				}

}

//Every eighth turn, lions attain and maintain eligibility to breed
//Lions will breed into a side-facing adjacent space at earliest opportunity
void Lion::breed(){
	bool alreadyBred = false;
	if (livedfor >= 8)
	{
		//any room to breed?
		vector<int> canBreed;//places I can breed to
	    canBreed.clear();
	
		    //can we breed north?
	                        if (x>0)
							{
								Ant *pAnt = dynamic_cast<Ant*>(this->world->getOrganism(x-1,y));//N
								Lion *pLion = dynamic_cast<Lion*>(this->world->getOrganism(x-1,y));
								if ((long)pLion == 0 && (long)pAnt == 0) //it's free; I can breed there
								{
									canBreed.push_back(N);
								}
							}
			
			//can we breed east?
							if (y<width-1)
							{
								Ant *pAnt = dynamic_cast<Ant*>(this->world->getOrganism(x,y+1));//E
								Lion *pLion = dynamic_cast<Lion*>(this->world->getOrganism(x,y+1));
								if ((long)pLion == 0 && (long)pAnt == 0)
								{
									canBreed.push_back(E);
								}
							}
			//can we breed south?
							if (x<height-1)
							{
								Ant *pAnt = dynamic_cast<Ant*>(this->world->getOrganism(x+1,y));//S
								Lion *pLion = dynamic_cast<Lion*>(this->world->getOrganism(x+1,y));
								if ((long)pLion == 0 && (long)pAnt == 0)
								{
									canBreed.push_back(S);
								}
							}
		   // can we breed west?
							if (y>0)
							{
								Ant *pAnt = dynamic_cast<Ant*>(this->world->getOrganism(x,y-1));//W
								Lion *pLion = dynamic_cast<Lion*>(this->world->getOrganism(x,y-1));
								if ((long)pLion == 0 && (long)pAnt == 0)
								{
									canBreed.push_back(W);
								}
							}

							//if we found an place to birth to, pick one to birth to at random
							if (canBreed.size() > 0)
							{
								birth(canBreed.at(this->world->genrand(canBreed.size())));
								alreadyBred = true;
							}

							if (alreadyBred)//reset counter
								livedfor = 0;
	}


}

//create new lion one space away in given direction
void Lion::birth(int dirIn){

	        if (dirIn==N)//create new lion one space north
			{
					Lion *pNewLion = new Lion(this->world, width, height);//make a new lion
					pNewLion->setPosition(x-1,y);//tell it where it is
					this->world->setOrganism(pNewLion,x-1,y);//plunk it on the grid
			}
			else if (dirIn==E)
			{
					Lion *pNewLion = new Lion(this->world, width, height);
					pNewLion->setPosition(x,y+1);
					this->world->setOrganism(pNewLion,x,y+1);
			}
			else if (dirIn==S)
			{
					Lion *pNewLion = new Lion(this->world, width, height);
					pNewLion->setPosition(x+1,y);
					this->world->setOrganism(pNewLion,x+1,y);
			}
			else //(dirIn==W)
			{
                    Lion *pNewLion = new Lion(this->world, width, height);
					pNewLion->setPosition(x,y-1);
					this->world->setOrganism(pNewLion,x,y-1);
			}
}

//lions that haven't eaten in three turns will die!
void Lion::starve(){

	//cout << "I'm at " << x << "," << y << " and I've last eaten " << lastate << " turns ago." << endl;

	if (lastate >= 3)
	{//we die :-(
		Organism *spaceFiller = new Organism;
		this->world->setOrganism(spaceFiller,x,y);//plunk nonce organism where I am
	}

}