//Lion.h - header for Lion class

#pragma once
#ifndef _Lion_H
#define _Lion_H

#include "Organism.h"
#include "World.h"
using namespace std;

class Lion : public Organism
{
protected:

	//# of time steps since it ate
	int lastate;

public:
	Lion(); //default constructor (just for type-testing)
	Lion( World *worldIn, int widthIn, int heightIn ); //"practical" constructor used for lions we want to use
	virtual ~Lion(); //virtual destructor

	void move(); //uniquely implemented move method
	void breed(); //uniquely implemented breed method
	void birth(int dirIn); //uniquely implemented internal birth method
	void starve(); //starve method (exclusive to lions)

	void eat(int dirIn); //internal eat method (called by move)
};

#endif
