//Organism.h - header for Organism class

#ifndef _Organism_H
#define _Organism_H

#include <iostream>
#include <vector>
#include <Windows.h>
using namespace std;

class World;

class Organism
{
protected:
	//# of time steps it has survived
	int livedfor;

	int x;//position in world
	int y;//position in world
	int width;//width of world - needed because we have a pointer to the world
	int height;//height of world - needed because we have a pointer to the world
	bool moved;//"false" - yet to move; "true" - already moved on this time step
	World *world;//pointer to the world

	//not used:
	enum Directions { N, E, S, W, NE, SE, SW, NW };

public:
	Organism();//constuctor (for space-filling and type-matching)
	virtual ~Organism();//virtual destructor

	//to be implemented by ants and lions:
	virtual void move();
	virtual void breed();
	virtual void birth(int dirIn);//internal birth method, called by breed

	//implementations that are appropriate for ants and lions
	//are defined here in Organism:
	void setPosition( int xin, int yin );
	void startTurn();
	void endTurn();
	bool isTurn();

	//output the character representing an organism:
	friend ostream& operator<<( ostream &output, Organism *organism );
};

#endif
